import java.awt.*;
public class Examples {
  // Test harness
  TestHarness th = new TestHarness();
  
  // Balloon data
  Balloon b1 = new Balloon(new CartPt(20, 40), 30, new Color(255, 0, 0));
  Balloon b2 = new Balloon(new CartPt(40, 30), 20, new Color(0, 255, 0));
  Balloon b3 = new Balloon(new CartPt(40, 20), 10, new Color(0, 0, 255));
  Balloon b4 = new Balloon(new CartPt(20, 20), 25, new Color(255, 0, 255));
  
  
  // TopThree data
  TopThree ttr = new TopThree(this.b1, this.b2, this.b3, new BalloonByRadius());
 
  public void showData(){
    System.out.println("Balloon b1 = " + this.b1.toString());
    System.out.println("Balloon b2 = " + this.b2.toString());
    System.out.println("Balloon b3 = " + this.b3.toString());
    System.out.println("Balloon b4 = " + this.b4.toString());

    System.out.println("TopThree ttr = " + this.ttr.toString());
}
  // Reset all data
  public void resetData(){

    this.b1 = new Balloon(new CartPt(20, 40), 30, new Color(255, 0, 0));
    this.b2 = new Balloon(new CartPt(40, 30), 20, new Color(0, 255, 0));
    this.b3 = new Balloon(new CartPt(40, 20), 10, new Color(0, 0, 255));
    this.b4 = new Balloon(new CartPt(20, 20), 25, new Color(255, 0, 255));
    this.ttr = new TopThree(this.b1, this.b2, this.b3, this.ttr.comp);
  }
  
  // Test the method inflateBalloon in the class Balloon
  public void testInflateBalloon(){
    this.resetData();
    this.b4.inflateBalloon(5);
    th.test("inflateBalloon 1: ", this.b4.radius, 30);    
  }

  // Test the method floatBalloon in the class Balloon
  public void testFloatBalloon(){
    this.resetData();
    this.b4.floatBalloon(5);
    th.test("floatBalloon 1: ", this.b4.loc.y, 15);    
  }
  
  // Test the method inflate in the class TopThree
  public void testInflate(){
    this.resetData();
    this.ttr.inflate(-10, 5, 20);
    th.test("inflateTT 1: ", this.ttr.one, this.b3);    
    th.test("inflateTT 2: ", this.ttr.two, this.b2);    
    th.test("inflateTT 3: ", this.ttr.three, this.b1);    
  }
  
  public static void main(String[] argv){
    Examples e = new Examples();
    
    e.showData();
    
    e.testInflateBalloon();
    e.testFloatBalloon();
    e.testInflate();
    
    e.th.testReport();
    e.th.fullTestReport();
  }
  
}