import java.util.*;

// class designed to illustrate the pitfalls of mutation
// data consists of three balloons ordered by the given Comparator 
public class TopThree implements ISame{
 
  public Balloon one;
  public Balloon two; 
  public Balloon three;
  public Comparator comp;
  
  // constructor assumes that the three balloons are ordered
  public TopThree(Balloon one, Balloon two, Balloon three, Comparator comp){
    this.one = one;
    this.two = two;
    this.three = three;
    this.comp = comp;
  }
  
  // inflate each balloon by the given amount and re-order the data
  public void inflate(int d1, int d2, int d3){
    this.one.inflateBalloon(d1);
    this.two.inflateBalloon(d2);
    this.three.inflateBalloon(d3);
  }
  
 
  
  // is this TopThree same as the given Object?
  public boolean same(Object obj){
    if (obj instanceof TopThree)
      return this.one.same(((TopThree)obj).one) &&
             this.two.same(((TopThree)obj).two) &&
             this.three.same(((TopThree)obj).three) &&
             this.comp.equals(((TopThree)obj).three);
    else
      throw new ClassCastException(
          "TopThree cannot be compared with " + obj.toString());
  }
  
  // represent the data in this instance as a String
  public String toString(){
    return 
    "new TopThree(\n" +
    "this.numberone = " + this.one.toString() +",\n" +
    "this.numbertwo = " + this.two.toString() +",\n" +
    "this.numberthree = " + this.three.toString() +")\n";
  }
}